#!/usr/bin/perl -w

$confGmetric = "/usr/bin/gmetric --tmax=700";
$confGanglia = "/etc/gmond.conf";

die "Ganglia is not installed" if ! -r $confGanglia;

my $verbose = grep(/-v/,@ARGV);

my $gmetricDest = "";

if (1)
  {
    my $ip;
    my $port;
    
    open(IN,"$confGanglia") || die "Cannot read $confGanglia";
    while (<IN>)
      {
        next if /^#/;
        $ip   = $1 if /mcast_channel +(.*)/;
        $port = $1 if /mcast_port +(.*)/;
      }
    close IN;
    
    $gmetricDest .= " -c$ip " if defined $ip;
    $gmetricDest .= " -p$port " if defined $port;
  }

$ENV{"LANG"} = "C";
$ENV{"TERM"} = "vt100";

my $xtime = 0;

my $now = time();
my @vmstat = split(/\n/,`vmstat -s`);

foreach my $s (@vmstat)
  {
    next unless $s =~ /^\s+(\d+)\s+(\w+.+)$/;
    my $count = int($1);
    my $name  = $2;
    $name =~ s/\s/_/g;
    #print "[$count][$name]\n";
    $count{$name} = $count;
  }

my $tmpfile = "/var/run/ganglia_vmstat.txt";
#my $tmpfile = "./ganglia_vmstat.txt";
if (-r $tmpfile)
  {
    open(FIN,$tmpfile);
    $xtime = int(<FIN>);
    my @fin = <FIN>;
    foreach my $in (@fin)
      {
        my ($name,$count) = split(/ +/,$in);
        $xcount{$name} = $count;
      }
    close FIN;

    die "Time goes backwards: $xtime -> $now" if ($xtime >= $now);
  }

my $dt = $now - $xtime;

#print "delta t is $dt sec\n";

die "Too little time ($dt sec) between calls to $0" if $dt < 10;

unlink $tmpfile;
open(FOUT,">$tmpfile") || die "Cannot write to $tmpfile: $!";
print FOUT "$now\n";
foreach my $k (sort keys %count)
  {
    print FOUT "$k $count{$k}\n";
  }
close FOUT;

die "Too much time ($dt sec) between calls to $0" if $dt > 30*60;

foreach my $k (sort keys %count)
  {
    my $v1 = $count{$k};
    my $v2 = $xcount{$k};
    next unless $v1 && $v2;
    my $val = ($v1 - $v2)/$dt;
    next if $val < 0;
    my $exec = "$confGmetric $gmetricDest -tfloat -n\"vmstat_$k\" -v\"$val\"";
    print "$exec\n" if $verbose;
    system $exec;
  }

exit 0;
#end file
